# Status history balloon plugin. Jet (megaxbit@xmpp.ru) 20090607 r1

namespace eval histballoon {
    if {![::plugins::is_registered histballoon]} {
	::plugins::register histballoon \
			    -namespace [namespace current] \
			    -source [info script] \
			    -description [::msgcat::mc "Status history balloon"] \
			    -loadcommand [namespace code load] \
			    -unloadcommand [namespace code unload]
	return
    }
	set statushist ""
}

######################################################################################

proc histballoon::set_status_hist {text} {
	variable statushist

	set timestamp "\[[clock format [clock seconds] -format %H:%M:%S]\]"
	set text "$timestamp $text"
	set tmplist $statushist

	lappend tmplist $text

	if {[llength $tmplist] >= 20} {
		set tmplist [lreplace $tmplist 0 0]
	}
	set statushist $tmplist
}

proc histballoon::get_statushist {} {
	variable statushist
	set result ""
	foreach s $statushist {
		append result $s \n
	}

	set endchar [expr [clength $result] - 2]
	set result [crange $result 0 $endchar]
	return $result
}

######################################################################################

proc histballoon::add_binds {} {
	bind .mainframe.status <Any-Enter> \
		[list eval ::balloon::set_text \[[namespace current]::get_statushist\]]		
	bind .mainframe.status <Any-Motion> \
		[list eval ::balloon::on_mouse_move \
			\[[namespace current]::get_statushist\] %X %Y]
	bind .mainframe.status.label <Any-Motion> \
		[list eval ::balloon::on_mouse_move \
			\[[namespace current]::get_statushist\] %X %Y]
	bind .mainframe.status <Any-Leave> ::balloon::destroy
}

proc histballoon::remove_binds {} {
	bind .mainframe.status <Any-Enter> {}
	bind .mainframe.status <Any-Motion> {}
	bind .mainframe.status.label <Any-Motion> {}
	bind .mainframe.status <Any-Leave> {}
}

######################################################################################

proc histballoon::load {} {
	hook::add set_status_hook [namespace current]::set_status_hist
	hook::add finload_hook [namespace current]::add_binds
	catch [namespace current]::add_binds
}

proc histballoon::unload {} {
	hook::remove set_status_hook [namespace current]::set_status_hist
	hook::remove finload_hook [namespace current]::add_binds
	catch [namespace current]::remove_binds
}